TeachTxtParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
TeachTxtParser Class Referencefinal

the main class to read a SimpleText/TeachText/Tex-Edit file More...

`#include <TeachTxtParser.hxx>`

Inheritance diagram for TeachTxtParser:

## Public Member Functions
| TeachTxtParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~TeachTxtParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | init ()
| inits all internal variables
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document
void | newPage (int number)
| adds a new page
bool | createZones ()
| finds the different objects zones
bool | readStyles (MWAWEntry const &entry)
| try to read the styles ( resource styl : SimpleText,id=128, Tex-Edit,id=1000 )
bool | readWRCT (MWAWEntry const &entry)
| try to read the unknown wrct structure ( only in TexEdit,id=1000 )
int | computeNumPages () const
| compute the number of page of a zone
bool | sendText ()
| try to send the main text
bool | sendPicture (int id)
| try to send a picture knowing the id
void | flushExtra ()
| sends the data which have not yet been sent to the listener
MWAWInputStreamPtr | rsrcInput ()
| return the input input
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< TeachTxtParserInternal::State > | m_state
| the state

## Detailed Description

the main class to read a SimpleText/TeachText/Tex-Edit file

## Constructor & Destructor Documentation

## ◆ TeachTxtParser()

TeachTxtParser::TeachTxtParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ◆ ~TeachTxtParser()

TeachTxtParser::~TeachTxtParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool TeachTxtParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| finalvirtual

checks if the document header is correct (or not)

no data fork, may be ok, but this means that the file contains no text, so...

visibly, some other applications can create ttxt file, so check that we have at least a styl rsrc or a PICT

Implements MWAWParser.

Referenced by parse().

## ◆ computeNumPages()

int TeachTxtParser::computeNumPages | ( |  | ) | const
| protected

compute the number of page of a zone

Referenced by createDocument().

## ◆ createDocument()

void TeachTxtParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool TeachTxtParser::createZones | ( |  | ) |
| protected

finds the different objects zones

checkme: find also two times BBSR:0x250 with size 0x168, probably not in the format..

Referenced by parse().

## ◆ flushExtra()

void TeachTxtParser::flushExtra | ( |  | ) |
| protected

sends the data which have not yet been sent to the listener

Referenced by parse().

## ◆ init()

void TeachTxtParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by TeachTxtParser().

## ◆ newPage()

void TeachTxtParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by sendText().

## ◆ parse()

void TeachTxtParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWTextParser.

## ◆ readStyles()

bool TeachTxtParser::readStyles | ( | MWAWEntry const & | entry | ) |
| protected

try to read the styles ( resource styl : SimpleText,id=128, Tex-Edit,id=1000 )

Referenced by createZones().

## ◆ readWRCT()

bool TeachTxtParser::readWRCT | ( | MWAWEntry const & | entry | ) |
| protected

try to read the unknown wrct structure ( only in TexEdit,id=1000 )

Referenced by createZones().

## ◆ rsrcAscii()

libmwaw::DebugFile & TeachTxtParser::rsrcAscii | ( |  | ) |
| protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by readStyles(), and readWRCT().

## ◆ rsrcInput()

MWAWInputStreamPtr TeachTxtParser::rsrcInput | ( |  | ) |
| protected

return the input input

Referenced by readStyles(), readWRCT(), and sendPicture().

## ◆ sendPicture()

bool TeachTxtParser::sendPicture | ( | int | id | ) |
| protected

try to send a picture knowing the id

Referenced by flushExtra(), and sendText().

## ◆ sendText()

bool TeachTxtParser::sendText | ( |  | ) |
| protected

try to send the main text

Referenced by parse().

## Member Data Documentation

## ◆ m_state

std::shared_ptr<TeachTxtParserInternal::State> TeachTxtParser::m_state
| protected

the state

Referenced by checkHeader(), computeNumPages(), createDocument(), createZones(), flushExtra(), init(), newPage(), readStyles(), sendPicture(), and sendText().

The documentation for this class was generated from the following files:

- TeachTxtParser.hxx
- TeachTxtParser.cxx